#NoTrayIcon
Opt("MustDeclareVars", 1)
Opt("TrayMenuMode", 3)
Opt("TrayOnEventMode", 1)
Const $prg = StringLeft(@ScriptName, StringInStr(@ScriptName, ".", 0, -1) -1)
Const $key = "HKCU\Software\Microsoft\Windows\CurrentVersion\Run"
If $CmdLine[0] > 0 Then
  Const $speech[2] = [$CmdLine[1], "SAPI"]
  Const $cmd = @ScriptFullPath & " " & $CmdLine[1]
Else
  Const $speech[2] = ["SAPI", "Speech"]
  Const $cmd = @ScriptFullPath
EndIf
Global $sapi, $max[2], $auto, $intervall, $rate, $min[2], $sek, $aktiv[2]
Global $a, $e, $i, $k, $m, $r, $s, $u, $z
Global $ini = StringLeft(@ScriptFullPath, StringInStr(@ScriptFullPath, ".", 0, -1)) & "ini"
If StringInStr(FileGetAttrib(@ScriptDir), "R") Then
  Global $dir = @LocalAppDataDir & "\" & $prg
  If Not FileExists($dir) Then
    If DirCreate($dir) = 0 Then
      MsgBox(16, $prg, "Das Datenverzeichnis konnte nicht angelegt werden.")
      Exit
    EndIf
  EndIf
  $ini = StringReplace($ini, @ScriptDir, $dir)
EndIf
#Include <misc.au3>
If _Singleton($prg, 1) = 0 Then
  MsgBox(64, $prg, "Das Programm luft bereits.")
  Exit
EndIf
If Init($speech[0]) Then
  If Init($speech[1]) Then
    MsgBox(16, $prg, "Auf diesem System scheint keine Sprachausgabe installiert zu sein oder es wurde keine deutsche Stimme gefunden.")
    Exit
  EndIf
EndIf
$max[1] = $sapi.GetAudioOutputs().Count()
Global $v[($max[0] + 1)], $o[($max[1] + 2)]
If RegRead($key, $prg) And @COMPILED Then
  $auto = 1
  If RegRead($key, $prg) <> $cmd Then RegWrite($key, $prg, "REG_SZ", $cmd)
Else
  $auto = 0
EndIf
IniLesen()
$sapi.Voice = $sapi.GetVoices("Name=" & $v[0]).Item(0)
$sapi.AudioOutputStream = Null
$sapi.Rate = $rate
$a = TrayCreateItem("Zeit &ansagen" & @TAB & "Windows+Alt+z")
TrayItemSetOnEvent($a, "ZeitAnsagen")
TraySetOnEvent(-7, "ZeitAnsagen")
HotKeySet("#!z", "ZeitAnsagen")
$s = TrayCreateItem("Zeit &sekundengenau ansagen" & @TAB & "Windows+Umschalt+z")
TrayItemSetOnEvent($s, "ZeitGenau")
HotKeySet("#+z", "ZeitGenau")
$m = TrayCreateItem("Sprachausgabe vorbergehend stu&mm schalten" & @TAB & "Windows+Strg+z")
TrayItemSetOnEvent($m, "Mute")
HotKeySet("#^z", "Mute")
If $max[0] > 1 Then
  $z = 1
  $v[0] = TrayCreateMenu("Stimme &whlen")
  For $voice In $sapi.GetVoices("Language=407")
    $v[$z] = TrayCreateItem($voice.GetAttribute("Name"), $v[0])
    TrayItemSetOnEvent($v[$z], "ChangeVoice")
    $z += 1
  Next
EndIf
If $max[1] > 1 Then
  $z = 2
  $o[1] = TrayCreateMenu("Sound&karte whlen")
  For $sound In $sapi.GetAudioOutputs()
    $o[$z] = TrayCreateItem($sound.GetDescription(), $o[1])
    TrayItemSetOnEvent($o[$z], "ChangeSound")
    If $sound.GetDescription() = $o[0] Then $sapi.AudioOutput = $sapi.GetAudioOutputs().Item($z - 2)
    $z += 1
  Next
EndIf
$r = TrayCreateItem("&Geschwindigkeit ndern")
TrayItemSetOnEvent($r, "SetRate")
$i = TrayCreateItem("Ansage&intervall einstellen")
TrayItemSetOnEvent($i, "SetIntervall")
$k = TrayCreateItem("&Einstellungen speichern")
TrayItemSetOnEvent($k, "IniSchreiben")
If @COMPILED Then
  $u = TrayCreateItem("fr aktuellen Benutzer automatisch &laden")
  TrayItemSetOnEvent($u, "Autostart")
  If $auto = 1 Then TrayItemSetState($u, 1)
EndIf
$e = TrayCreateItem($prg & " &beenden" & @TAB & "Windows+F4")
TrayItemSetOnEvent($e, "_Exit")
HotKeySet("#{F4}", "_Exit")
TraySetClick(8)
TraySetState()
SetToolTip()
$min[0] = @min
ZeitAnsagen()
While 1
  If $min[0] <> @min Then 
    $min[0] = @min
    $min[1] = (@hour * 60) + @min
    If ($intervall > 0) And Not BitAND(TrayItemGetState($m), 1) Then
      If ((@hour >= $aktiv[0]) And ((@hour * 60 + @min) <= ($aktiv[1] * 60))) _
      Or (($aktiv[1] >= 24) And (@hour >= $aktiv[0]) Or ((@hour * 60 + @min) <= (($aktiv[1] - 24) * 60))) Then
        If Mod($min[1], $intervall) = 0 Then ZeitAnsagen()
      EndIf
    EndIf
  EndIf
  Sleep(250)
WEnd
Exit

Func Init($api)
  $sapi = ObjCreate($api & ".SPVoice")
  If @ERROR Then Return @ERROR
  $max[0] = $sapi.GetVoices("Language=407").Count()
  If $max[0] = 0 Then Return -1
EndFunc

Func ZeitAnsagen()
  Local $zeit = "Es ist "
  If @hour = 1 Then
    $zeit &= "ein Uhr"
  Else
    $zeit &= StringFormat("%d Uhr", @hour)
  EndIf
  If @min > 0 Then $zeit &= StringFormat(" %d", @min)
  $zeit &= $sek
  $sek = ""
  If $sapi.Status.RunningState <> 2 Then $sapi.Speak($zeit)
EndFunc

Func ZeitGenau()
  If @sec = 1 Then
    $sek = " und eine Sekunde"
  Else
    $sek = StringFormat(" und %d Sekunden", @sec)
  EndIf
  ZeitAnsagen()
EndFunc

Func Mute()
  If BitAND(TrayItemGetState($m), 1) Then
    TrayItemSetState($m, 4)
    $sapi.Speak("Stummschaltung aufgehoben.")
  Else
    TrayItemSetState($m, 1)
    $sapi.Speak("Sprachausgabe stummgeschaltet.")
  EndIf
  SetToolTip()
EndFunc

Func ChangeVoice()
  $sapi.Voice = $sapi.GetVoices("Name=" & TrayItemGetText(@TRAY_ID)).Item(0)
  $sapi.AudioOutputStream = Null
  SetToolTip()
  ZeitAnsagen()
EndFunc

Func ChangeSound()
  $sapi.AudioOutput = $sapi.GetAudioOutputs().Item(@TRAY_ID - $o[1] - 1)
  SetToolTip()
  ZeitAnsagen()
EndFunc

Func SetRate()
  Do
    $rate = CheckVal($rate, $sapi.Rate)
    $rate = InputBox($prg, "Bitte geben Sie die gewnschte Geschwindigkeit ein (-10 bis 10)", $rate)
  Until StringIsInt($rate)
  $rate = Int($rate)
  If ($rate < -10) Or ($rate > 10) Then
    MsgBox(16, $prg, "Die Geschwindigkeit muss zwischen -10 und 10 liegen.")
    If $rate < -10 Then $rate = -10
    If $rate > 10 Then $rate = 10
  EndIf
  $sapi.Rate = $rate
  SetToolTip()
  ZeitAnsagen()
EndFunc

Func SetIntervall()
  Do
    $intervall = CheckVal($intervall, 15)
    $intervall = InputBox($prg, "Bitte geben Sie das Ansageintervall ein (z. B. 15 fr viertelstndlich)", $intervall)
  Until StringIsInt($intervall)
  $intervall = Int($intervall)
  If $intervall < 0 Then
    MsgBox(16, $prg, "Das Ansageintervall muss grer oder gleich 0 sein.")
    $intervall = 0
  EndIf
  If $intervall > 0 Then
    If $aktiv[1] >= 24 Then $aktiv[1] -= 24
    Do
      $aktiv[0] = CheckVal($aktiv[0], 6)
      $aktiv[0] = InputBox($prg, "Ab welcher vollen Stunde soll die Zeit angesagt werden (0 bis 23)?", $aktiv[0])
    Until StringIsInt($aktiv[0])
    $aktiv[0] = Int($aktiv[0])
    If ($aktiv[0] < 0) Or ($aktiv[0] > 23) Then
      MsgBox(16, $prg, "Der Beginn der Ansage muss zwischen 0 und 23 liegen.")
      If $aktiv[0] < 0 Then $aktiv[0] = 0
      If $aktiv[0] > 23 Then $aktiv[0] = 23
    EndIf
    Do
      $aktiv[1] = CheckVal($aktiv[1], 22)
      $aktiv[1] = InputBox($prg, "Bis zu welcher vollen Stunde soll die Zeit angesagt werden (0 bis 23)?", $aktiv[1])
    Until StringIsInt($aktiv[1])
    $aktiv[1] = Int($aktiv[1])
    If ($aktiv[1] < 0) Or ($aktiv[1] > 23) Then
      MsgBox(16, $prg, "Das Ende der Ansage muss zwischen 0 und 23 liegen.")
      If $aktiv[1] < 0 Then $aktiv[1] = 0
      If $aktiv[1] > 23 Then $aktiv[1] = 23
    EndIf
    If $aktiv[1] <= $aktiv[0] Then $aktiv[1] += 24
  EndIf
  SetToolTip()
EndFunc

Func CheckVal($val, $def)
  If Not StringIsInt($val) Then
    MsgBox(16, $prg, "Ungltige Eingabe!" & @CRLF & "Sie drfen hier nur Ziffern eingeben.")
    Return Int($def)
  Else
    Return Int($val)
  EndIf
EndFunc

Func SetToolTip()
  Local $tt = $prg & " ("
  If BitAND(TrayItemGetState($m), 1) Then
    $tt &= "vorbergehend stumm geschaltet)"
  Else
    If $max[0] > 1 Then $tt &= "Stimme: " & $sapi.Voice.GetAttribute("Name") & ", "
    If $max[1] > 1 Then $tt &= "Soundkarte: " & $sapi.AudioOutput.GetDescription()
    $tt &= ")"
    TrayItemSetText($r, "&Geschwindigkeit ndern (" & $rate & ")")
    If $intervall = 0 Then
      TrayItemSetText($i, "Ansage&intervall einstellen (" & $intervall & ")")
    Else
      If $aktiv[1] >= 24 Then
        TrayItemSetText($i, "Ansage&intervall einstellen (" & $intervall & _
        " Min., " & $aktiv[0] & " - " & ($aktiv[1] -24) & " Uhr)")
      Else
        TrayItemSetText($i, "Ansage&intervall einstellen (" & $intervall & _
        " Min., " & $aktiv[0] & " - " & $aktiv[1] & " Uhr)")
      EndIf
    EndIf
    If StringLen($tt) > 128 Then $tt = StringReplace($tt, ", Soundkarte: ", " (") & ")"
    If StringLen($tt) > 128 Then $tt = StringReplace($tt, "Stimme: ", "")
  EndIf
  TraySetToolTip($tt)
EndFunc

Func Autostart()
  If $auto = 1 Then
    If RegDelete($key, $prg) = 1 Then
      $auto = 0
      TrayItemSetState($u, 4)
    EndIf
  Else
    If RegWrite($key, $prg, "REG_SZ", $cmd) = 1 Then
      $auto = 1
      TrayItemSetState($u, 1)
    EndIf
  EndIf
  If FileExists($ini) Then IniWrite($ini, $prg, "Autostart", $auto)
EndFunc

Func IniLesen()
  If FileExists($ini) Then
    $v[0] = IniRead($ini, $prg, "Stimme", $sapi.GetVoices("Language=407").Item(0).GetAttribute("Name"))
    $o[0] = IniRead($ini, $prg, "Soundkarte", $sapi.AudioOutput.GetDescription())
    $rate = Int(IniRead($ini, $prg, "Geschwindigkeit", $sapi.Rate))
    $intervall = Int(IniRead($ini, $prg, "Intervall", 15))
    $aktiv[0] = Int(IniRead($ini, $prg, "Ansage_ab", 6))
    $aktiv[1] = Int(IniRead($ini, $prg, "Ansage_bis", 22))
    If $aktiv[1] <= $aktiv[0] Then $aktiv[1] += 24
    If @COMPILED Then
      $auto = Int(IniRead($ini, $prg, "Autostart", $auto))
      If $auto < 0 Then $auto = 0
      If $auto > 1 Then $auto = 1
      If $auto = 1 Then
        If RegRead($key, $prg) <> $cmd Then RegWrite($key, $prg, "REG_SZ", $cmd)
      Else
        If RegRead($key, $prg) Then RegDelete($key, $prg)
      EndIf
    EndIf
  Else
    $v[0] = $sapi.GetVoices("Language=407").Item(0).GetAttribute("Name")
    $o[0] = $sapi.AudioOutput.GetDescription()
    $rate = $sapi.Rate
    $intervall = 15
    $aktiv[0] = 6
    $aktiv[1] = 22
  EndIf
EndFunc

Func IniSchreiben()
  If $max[0] > 1 Then IniWrite($ini, $prg, "Stimme", $sapi.Voice.GetAttribute("Name"))
  If $max[1] > 1 Then IniWrite($ini, $prg, "Soundkarte", $sapi.AudioOutput.GetDescription())
  IniWrite($ini, $prg, "Geschwindigkeit", $sapi.Rate)
  IniWrite($ini, $prg, "Intervall", $intervall)
  IniWrite($ini, $prg, "Ansage_ab", $aktiv[0])
  If $aktiv[1] >= 24 Then
    IniWrite($ini, $prg, "Ansage_bis", ($aktiv[1] - 24))
  Else
    IniWrite($ini, $prg, "Ansage_bis", $aktiv[1])
  EndIf
  If @COMPILED Then IniWrite($ini, $prg, "Autostart", $auto)
  $sapi.Speak("Einstellungen gespeichert.")
EndFunc

Func _Exit()
  $sapi.Speak($prg & " beendet.")
  Exit
EndFunc